/* Generador de Poesia
 
 Aquest programa crea una estructura que ha de ser completada
 per els humans que col·laborin en la creació literària. És una 
 mescla de col·laboracions entre algoritmes, aleatorietat i humans. 
 */


// Variables del projecte (es poden canviar)
int NombreEstrofes = int(random(1, 5)); // Escull a l'atzar un nombre d'estrofes
int NumeroVersos = int(random(2, 5)); // Escull a l'atzar un número de versos per estrofa
String ParaulesClau[] = {"Intel·ligència artificial", "flora", "emocions", "conflicte", "dispositius electrònics", "elements humans"}; // Recomanat fer un mínim de 3 paraules clau
String Noms[] = {"Alejandro", "Laia", "Clara", "Quico", "Queral"}; //podeu afegir o treure persones sempre entre cometes i separats per comes.
String TextResultant  = ""; // creem una variable que anirà recollint tot el text del procés. Començem en blanc. 
String NomDocument = "";

// Configuració per una execució del programa

void setup() { // configurem l'entorn on farem el poema obrim '{' i seguim fins a tancar-les '}' 
  NouFullEnBlanc("A4");
  NouBorrador("indiferent");
  Titol ();  //funció que fa escriure el títol
  EscriurePoema(); // Funció que fa escriure el poema als autors
  Signar(); // Funció que fa signar
  Resultat(); // Funció que guarda el document en un arxiu txt.
}

// Bucle principal i funcions a seguir

void NouFullEnBlanc(String formatDeFull) {
  // un humà agafa un full que correspongui al valor que s'ha escrit al cridar la funció

  TextResultant = TextResultant + "Aquest document s'ha de treballar en un full " + formatDeFull + "\n" + "En/na " + Noms[int(random(Noms.length))] + " agafa el full i el col·loca en un lloc on totes hi puguin participar i s'encarrega d'anar-lo movent segons les necessitats. \n";

  // "\n" és un salt de línea;
}

void NouBorrador(String formatDeFull) {
  // un humà agafa un full per fer servir de borrador, que correspongui al valor que s'ha escrit al cridar la funció
  TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + " ha d'agafar un full borrador de format " + formatDeFull + " i s'encarrega de moure'l entre els/les participants en cas de necessitar-lo \n";
}

void Titol() {
  // es defineix el títol del poema i es demana que algú ho escrigui en el full en blanc.
  NomDocument = "'Poema del "+ day() + " del " + month() + " de " + year() + " sobre " + ParaulesClau[int(random(ParaulesClau.length))] + " entre d'altres coses' ";

  TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + ", amb un rotulador o color diferent, escriu el títol al full en blanc: " + NomDocument + "\n";
}

void EscriurePoema() {
  // es defineix el títol del poema i es demana que algú ho escrigui en el full en blanc.
  TextResultant = TextResultant + "A partir d'ara es fa servir un bolígraf o llapis regular. \n";
  TextResultant = TextResultant + "S'escriurà un poema amb " + NombreEstrofes + " estrofes de " + NumeroVersos + " versos cada estrofa. \n";
  for (int estrofa = 0; estrofa < NombreEstrofes; estrofa ++) { // Mentres que hi hagi estrofes pendents, es fa començar una estrofa.
    TextResultant = TextResultant + "Començem una estrofa nova. \n";
    for (int vers = 0; vers < NumeroVersos; vers ++) { // Mentres que hi hagi estrofes pendents, es fa començar una estrofa.
      if (vers < NumeroVersos-1) {
        TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + " escriu al full de borrador un vers basat en la paraula clau " + ParaulesClau[int(random(ParaulesClau.length))] + "\n";
        TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + " revisa el text del borrador que s'acaba d'escriure  i decideix si el deixa tal qual i el marca com a vàlid o si el reescriu amb total llibertat sense passar-lo a net. \n";
      } else {
        TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + " escriu al borrador l'últim vers de l'estrofa, basat en la paraula clau " + ParaulesClau[int(random(ParaulesClau.length))] + "\n";
        TextResultant = TextResultant + "En/na " + Noms[int(random(Noms.length))] + " reescriu el vers anterior assegurant que rimi amb el vers anterior o el primer vers de l'estrofa."; 
        TextResultant = TextResultant + "Entre totes es decideix passar en net totes les parts de l'estrofa amb llibertat per fer revisions. \n";
      }
    }
  }
  TextResultant = TextResultant + "Deixem un espai en blanc. \n";
}
void Signar() {
  // es defineix el títol del poema i es demana que algú ho escrigui en el full en blanc.
  for (int i = 0; i < Noms.length; i ++) { // Mentres que hi hagi autors a la llista de noms
    TextResultant = TextResultant + "En/na " + Noms[i] + " signa el poema en el document final. \n";
  }
}
void Resultat() {
  String TextResultant2[] = {TextResultant};
  saveStrings(NomDocument + millis() + ".txt", TextResultant2);
  println(TextResultant);
  exit();
}
